#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;

const int MAXP = 100;
const int MAXD = 1000;
const int MAXV = 1000;

bool repeated(int x[], int y[], int z[], int n)
{
	for(int i=0; i<n; i++)
		if (x[i] == x[n] && y[i] == y[n] && z[i] == z[n])
			return true;
	return false;
}

int main()
{
	int n, dx, dy, dz;
	int mass, v;
	int x[MAXP], y[MAXP], z[MAXP];
	int icase=0;

	cin >> n >> dx >> dy >> dz;
		if (n <= 0 || n > MAXP) {
			cout << "ERROR: incorrect number of planetoids: " << n << endl;
return 1;
}
		if (dx <= 0 || dx > MAXD) {
			cout << "ERROR: incorrect dimension: " << dx << endl;
return 2;
}
		if (dy <= 0 || dy > MAXD) {
			cout << "ERROR: incorrect dimension: " << dy << endl;
return 3;
}
		if (dz <= 0 || dz > MAXD) {
			cout << "ERROR: incorrect dimension: " << dz << endl;
return 4;
}
		for(int i=0; i<n; i++) {
			cin >> mass;
			if (mass<=0 ||mass > 100) {
				cout << "ERROR: invalid mass on planetoid "<< i << ": " << mass << endl;
return 5;}
			cin >> x[i] >> y[i] >> z[i];
			if (x[i] < 0 || x[i] >= dx) {
				cout << "ERROR: invalid x dim on planetoid "<< i << ": " << x[i] << endl;
return 6;}
			if (y[i] < 0 || y[i] >= dy) {
				cout << "ERROR: invalid y dim on planetoid "<< i << ": " << y[i] << endl;
return 7;}
			if (z[i] < 0 || z[i] >= dz) {
				cout << "ERROR: invalid z dim on planetoid "<< i << ": " << z[i] << endl;
return 8;}
			if (repeated(x, y, z, i)) {
				cout << "ERROR: repeated planetoid position "<< i << ": " << x[i] << ',' << y[i] << ',' << z[i] << endl;
return 9; }
			cin >> v;
			if (v < -MAXV || v > MAXV) {
				cout << "ERROR: planetoid " << i << " invalid x velocity: " << v << endl;
return 10;
}
			cin >> v;
			if (v < -MAXV || v > MAXV) {
				cout << "ERROR: planetoid " << i << " invalid x velocity: " << v << endl;
return 11;
}
			cin >> v;
			if (v < -MAXV || v > MAXV) {
				cout << "ERROR: planetoid " << i << " invalid z velocity: " << v << endl;
return 12;
}
		}
return 42;
}
