#include <iostream>
//#include <unordered_map>
using namespace std;

const int MAXP = 10000;

class planetoid
{
public:
	long long mass;
	long long xyz[3];
	long long v[3];
	long long sxyz[3];	// location of at time of last intersection
} pl[MAXP];

long dim[3];

bool foundMatch(int n, int& numMatch, int& low)
{
    bool match = false;
    numMatch = 1;
    for(int i=0; i<n; i++) {
        for(int j=i+1; j<n; j++) {
            if (pl[i].xyz[0] == pl[j].xyz[0] &&
                pl[i].xyz[1] == pl[j].xyz[1] &&
                pl[i].xyz[2] == pl[j].xyz[2]) {
                    numMatch++;
                    match = true;
                }
        }
        if (match) {
            low = i;
            return true;
        }
    }
    return false;
}

bool Less_Than(const planetoid& a, const planetoid& b){
  if(a.mass < b.mass)
    return true;
  if(a.mass == b.mass){
    if(a.xyz[0] > b.xyz[0])
      return true;
    if(a.xyz[0] == b.xyz[0]){
      if(a.xyz[1] > b.xyz[1])
	return true;
      if(a.xyz[1]==b.xyz[1]){
	if(a.xyz[2] > b.xyz[2])
	  return true;
      }
    }
  }
  return false;
}

void Swap_Long(long long & a, long long& b){
  long long temp = a;
  a = b;
  b = temp;
}

void Swap(planetoid& a, planetoid& b){
  Swap_Long(a.mass, b.mass);
  for(int i = 0; i < 3; i++){
    Swap_Long(a.xyz[i], b.xyz[i]);
    Swap_Long(a.v[i], b.v[i]);
    Swap_Long(a.sxyz[i], b.sxyz[i]);
  }
}

int main()
{
	int n;
	cin >> n >> dim[0] >> dim[1] >> dim[2];
		for(int i=0; i<n; i++) {
			cin >> pl[i].mass;
			cin >> pl[i].xyz[0] >> pl[i].xyz[1] >> pl[i].xyz[2];
			cin >> pl[i].v[0] >> pl[i].v[1] >> pl[i].v[2];
			pl[i].sxyz[0] = pl[i].xyz[0];
			pl[i].sxyz[1] = pl[i].xyz[1];
			pl[i].sxyz[2] = pl[i].xyz[2];
		}
		bool repeatedState = false;;
int t = 0;

		while (true) {
t++;
//if (t == 990) cout << "Time " << t << ", number of planetoids = " << n << endl;
			repeatedState = true;
			for(int i=0; i<n; i++) {
//if (t == 990) cout << "  planetoid " << i << " at";
                for(int k=0; k<3; k++) {
                    pl[i].xyz[k] += pl[i].v[k];
                    pl[i].xyz[k] %= dim[k];
                    if (pl[i].xyz[k] < 0)
                        pl[i].xyz[k] += dim[k];
//if (t == 990) cout << ' ' << pl[i].xyz[k];
                    if (pl[i].xyz[k] != pl[i].sxyz[k])
                        repeatedState = false;
                }
//if (t == 990) cout << endl;
            }
            if (repeatedState /* || t > 10000/**/)
                break;
            bool match = false;
            int num, lowest;
            while (foundMatch(n, num, lowest)) {
                match = true;
                for(int i=n-1; i>lowest; i--) {
                    if (pl[i].xyz[0] == pl[lowest].xyz[0] &&
                        pl[i].xyz[1] == pl[lowest].xyz[1] &&
                        pl[i].xyz[2] == pl[lowest].xyz[2]) {
                            pl[lowest].mass += pl[i].mass;
                            pl[lowest].v[0] += pl[i].v[0];
                            pl[lowest].v[1] += pl[i].v[1];
                            pl[lowest].v[2] += pl[i].v[2];
                            pl[i] = pl[--n];
/*
cout << "Planetoids " << i << " and " << lowest << " meet at time " << t << " at location (";
cout << pl[i].ixyz[0] << ',';
cout << pl[i].ixyz[1] << ',';
cout << pl[i].ixyz[2] << ')' << endl;
/**/
                        }
                }
                pl[lowest].v[0] /= num;
                pl[lowest].v[1] /= num;
                pl[lowest].v[2] /= num;
            }
            if (match) {
                for(int i=0; i<n; i++) {
                    pl[i].sxyz[0] = pl[i].xyz[0];
                    pl[i].sxyz[1] = pl[i].xyz[1];
                    pl[i].sxyz[2] = pl[i].xyz[2];
                }
            }
		}

		for(int i = 0; i < n; i++)
		  for(int j = 0; j < n-1; j++){
		    if(Less_Than(pl[j], pl[j+1]))
		      Swap(pl[j], pl[j+1]);
		  }
	
		cout << n << endl;
		for(int i=0; i<n; i++) {
			cout << "P" << i << ": " << pl[i].mass;
			for(int k=0; k<3; k++)
				cout << ' ' << pl[i].sxyz[k];
			for(int k=0; k<3; k++)
				cout << ' ' << pl[i].v[k];
			cout << endl;
		}
}
